Bug 175563 - need to be able to probe for usb storage using ub
need to be able to probe for usb storage using ub
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: kudzu (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jeremy Katz
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2005-12-12 15:19 EST by Jeremy Katz
Modified: 2008-03-10 23:52 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-03-10 23:52:55 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
Greg's mail with patch (5.43 KB, text/plain)
2005-12-14 01:52 EST, Pete Zaitcev
no flags Details

  None (edit)
Description Jeremy Katz 2005-12-12 15:19:34 EST
If you have a multi-function device (like one of the many card readers that are
on all of the intel SDVs), you end up with 5 different versions of the
/sys/bus/usb/drivers/ub/1-4:1.0/block symlink pointing to each of
/sys/block/ub[abcde]
Comment 1 Pete Zaitcev 2005-12-12 15:38:21 EST
Wow, awesome. No idea how I accomplished it though...

[zaitcev@lembas ksrc]$ ls -l
/sys/devices/pci0000:00/0000:00:1d.7/usb2/2-6/2-6.2/2-6.2.4/2-6.2.4:1.0
total 0
-r--r--r-- 1 root root 4096 Dec 12 12:39 bAlternateSetting
-r--r--r-- 1 root root 4096 Dec 12 12:38 bInterfaceClass
-r--r--r-- 1 root root 4096 Dec 12 12:38 bInterfaceNumber
-r--r--r-- 1 root root 4096 Dec 12 12:38 bInterfaceProtocol
-r--r--r-- 1 root root 4096 Dec 12 12:38 bInterfaceSubClass
lrwxrwxrwx 1 root root    0 Dec 12 12:39 block -> ../../../../../../../../block/ubd
lrwxrwxrwx 1 root root    0 Dec 12 12:39 block -> ../../../../../../../../block/ubd
lrwxrwxrwx 1 root root    0 Dec 12 12:39 block -> ../../../../../../../../block/ubd
lrwxrwxrwx 1 root root    0 Dec 12 12:39 block -> ../../../../../../../../block/ubd
-r--r--r-- 1 root root 4096 Dec 12 12:38 bNumEndpoints
lrwxrwxrwx 1 root root    0 Dec 12 12:38 bus -> ../../../../../../../../bus/usb
-r--r--r-- 1 root root 4096 Dec 12 12:39 diag
lrwxrwxrwx 1 root root    0 Dec 12 12:38 driver ->
../../../../../../../../bus/usb/drivers/ub
drwxr-xr-x 2 root root    0 Dec 12 12:38 ep_02
drwxr-xr-x 2 root root    0 Dec 12 12:38 ep_81
-r--r--r-- 1 root root 4096 Dec 12 12:38 modalias
drwxr-xr-x 2 root root    0 Dec 12 12:38 power
--w------- 1 root root 4096 Dec 12 12:39 uevent
[zaitcev@lembas ksrc]$ cat /proc/version
Linux version 2.6.14-1.1740_FC5 (bhcompile@tweety.build.redhat.com) (gcc version
4.0.2 20051109 (Red Hat 4.0.2-6)) #1 Mon Dec 5 20:16:11 EST 2005
[zaitcev@lembas ksrc]$

Though in this case, they all point to /dev/ubd.
Comment 2 Jeremy Katz 2005-12-12 15:58:09 EST
Hmm, they're all pointing to ube on my box.  Maybe I was blind before and not
actually reading it right.  But, yeah, still seems a little wrong. :)
Comment 3 Pete Zaitcev 2005-12-14 01:50:51 EST
Upstream (Greg) proposes to change "block" symlink into "block:uba".
Is this solution acceptable?
Comment 4 Pete Zaitcev 2005-12-14 01:52:38 EST
Created attachment 122215 [details]
Greg's mail with patch
Comment 5 Jeremy Katz 2005-12-14 11:32:41 EST
We can make it work, but ugh, I know that's going to break things in userspace
which expect the symlink for the block device to be named "block".  So much for
sysfs stability! :-)
Comment 6 Jeremy Katz 2005-12-14 18:05:43 EST
Actually, this is problematic.  It makes it so that the single device directory
corresponds to more than one device which we can't handle with kudzu :-(
Comment 7 Pete Zaitcev 2006-05-17 22:18:27 EDT
Jeremy, I'm very sorry, but may I hide somewhere from your wrath?
I'm afraid of adding another directory on my own (in order to disambiguate
the symlinks), all this kobject stuff is too scary. Any new oopses will
discredit ub.
Comment 8 Jeremy Katz 2006-05-22 13:04:10 EDT
Yeah, we'll make things work with block:uba or whatever.  
Comment 9 Bill Nottingham 2008-03-10 23:52:55 EDT
I think we punted this. In any case, anaconda isn't using kudzu for probing any
more.

Note You need to log in before you can comment on or make changes to this bug.